# Generated by Django 5.0.8 on 2024-10-15 16:41

import django.core.validators
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("core", "0029_alter_userprofile_date_of_birth"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Document",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                ("title", models.CharField(max_length=255, verbose_name="Title")),
                (
                    "file",
                    models.FileField(
                        upload_to="documents/",
                        validators=[django.core.validators.FileExtensionValidator(["pdf"])],
                        verbose_name="File",
                    ),
                ),
                ("updated_at", models.DateTimeField(auto_now=True, verbose_name="Last modified")),
                (
                    "attached_to",
                    models.ManyToManyField(
                        related_name="documents", to="core.event", verbose_name="Attached to"
                    ),
                ),
                (
                    "uploader",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="Uploader",
                    ),
                ),
            ],
        ),
    ]
